/*2:*/
#line 100 "eggdata.w"

#include "config.h"                   


#line 103 "eggdata.w"


/*4:*/
#line 149 "eggdata.w"

#include "eggdata.h"        

/*:4*/
#line 105 "eggdata.w"

/*5:*/
#line 156 "eggdata.w"

/*9:*/
#line 241 "eggdata.w"


bool csv_parser::next_field(string&f){
string fld("");
bool foundfield= false,quoted= false;

if(chars_left(1)){
foundfield= true;
while(chars_left(1)&&isspace(line_buffer[charpos])){
charpos++;
}
if(chars_left(1)){
if(line_buffer[charpos]=='"'){
/*10:*/
#line 294 "eggdata.w"

quoted= true;
charpos++;
while(chars_left(1)){
if(line_buffer[charpos]=='"'){
if(chars_left(2)&&(line_buffer[charpos+1]=='"')){
fld+= '"';
charpos+= 2;
}else{
charpos++;
break;
}
}else if(line_buffer[charpos]=='\\'&&chars_left(2)){
if(line_buffer[charpos+1]=='\\'){
fld+= '\\';
charpos+= 2;
}else if(chars_left(4)&&
isOctal(line_buffer[charpos+1])&&
isOctal(line_buffer[charpos+2])&&
isOctal(line_buffer[charpos+3])){
char v;

v= ((line_buffer[charpos+1]-'0')<<6)|
((line_buffer[charpos+2]-'0')<<3)|
(line_buffer[charpos+3]-'0');
fld+= (char)v;
charpos+= 4;
}else{
fld+= line_buffer[charpos+1];
charpos+= 2;
}
}else{
fld+= line_buffer[charpos++];
}
}

/*:10*/
#line 254 "eggdata.w"
;
}
while(chars_left(1)&&line_buffer[charpos]!=','){
fld+= line_buffer[charpos++];
}
if(chars_left(1)){
charpos++;
pending_field= true;
}else{
pending_field= false;
}
}
}
if(foundfield&&!quoted){
while((fld.length()> 0)&&
isspace(fld[fld.length()-1])){
fld.erase(fld.length()-1);
}
}
if(foundfield){
f= fld;
}else if(pending_field){
f= fld;
foundfield= true;
pending_field= false;
}
return foundfield;
}

/*:9*//*45:*/
#line 1550 "eggdata.w"

string eggdatabases::database_file(systemtime t,string which)
{
return path(which)+"/basketdata-"+t.dateToString()+".csv.gz";
}

/*:45*//*63:*/
#line 1991 "eggdata.w"

void egg_properties::setFromCSV(string s){
csv_parser p(s);
string f;
int i,m_type,s_type,arg;

if(!p.next_field(f)||f.length()<1||!isdigit(f[0])){
throw(out_of_range("egg_properties::setFromCSV: Invalid record type"));
}

m_type= atoi(f.c_str());

switch(m_type){
case 41:
/*64:*/
#line 2036 "eggdata.w"

if(!p.next_field(f)||f.length()<1||!isdigit(f[0])){
throw(out_of_range("egg_properties::setFromCSV: Invalid egg number in type 41 record"));
}
eggNumber= atoi(f.c_str());
assert(eggNumber> 0);

if(!p.next_field(f)||f.length()<1){
throw(out_of_range("egg_properties::setFromCSV: Invalid latitude in type 41 record"));
}
latitude= atof(f.c_str());
assert(latitude>=-90&&latitude<=90);

if(!p.next_field(f)||f.length()<1){
throw(out_of_range("egg_properties::setFromCSV: Invalid longitude in type 41 record"));
}
longitude= atof(f.c_str());
assert(longitude>=-180&&longitude<=180);

if(!p.next_field(f)||f.length()<1){
throw(out_of_range("egg_properties::setFromCSV: Invalid altitude in type 41 record"));
}
if((f=="NA")||(f=="?")){
altitude= unknownAltitude;
}else{
altitude= atof(f.c_str());
assert(longitude>=-180&&longitude<=180);
}

if(!p.next_field(f)||f.length()<1){
throw(out_of_range("egg_properties::setFromCSV: Invalid location in type 41 record"));
}
location= f;

if(!p.next_field(f)||f.length()<1){
throw(out_of_range("egg_properties::setFromCSV: Invalid REG type in type 41 record"));
}
REGtype= f;

if(!p.next_field(f)||f.length()<1){
throw(out_of_range("egg_properties::setFromCSV: Invalid host name in type 41 record"));
}
if(f=="NA"){
f= "";
}
hostName= f;

/*:64*/
#line 2005 "eggdata.w"
;
break;

default:
throw(out_of_range("egg_properties::setFromCSV: Invalid record type"));
break;

}
}

/*:63*//*65:*/
#line 2087 "eggdata.w"

void egg_properties::describe(ostream&os){
os<<"Egg "<<eggNumber<<":"<<endl;
os<<"  Latitude: "<<latitude<<"  Longitude: "<<longitude<<
"  Altitude: "<<altitude<<endl;
os<<"  Location: "<<location<<"  REG type: "<<REGtype<<
"  Host name: "<<hostName<<endl;
}

/*:65*//*66:*/
#line 2102 "eggdata.w"

void egg_properties::tabulate(ostream&os){
os.setf(ios::fixed,ios::floatfield);
os.precision(3);
os<<setw(4)<<eggNumber<<"  "<<
setw(10)<<latitude<<" "<<
setw(10)<<longitude<<" ";
if(isAltitudeKnown()){
os<<setw(6)<<setprecision(0)<<altitude<<"  ";
}else{
os<<"  N.A.  ";
}
os.setf(ios::left,ios::adjustfield);
os<<setw(10)<<REGtype.c_str()<<" "<<
setw(24)<<location.c_str()<<" "<<
hostName.c_str()<<
endl;
os.setf(ios::right,ios::adjustfield);
os.precision(6);
}

/*:66*//*68:*/
#line 2148 "eggdata.w"

unsigned int egg_properties_database::size(void){
return eggs.size();
}

/*:68*//*69:*/
#line 2158 "eggdata.w"

egg_properties*egg_properties_database::find(unsigned int egg_number){
map<unsigned int,egg_properties*> ::iterator p= eggs.find(egg_number);

return(p==eggs.end())?NULL:p->second;
}

/*:69*//*70:*/
#line 2169 "eggdata.w"

egg_properties*egg_properties_database::operator[](int n){
return eggv[n];
}

/*:70*//*71:*/
#line 2178 "eggdata.w"

void egg_properties_database::loadFromCSV(istream&i){
string s;

while(getline(i,s)){
if((s.length()> 0)&&(s[0]!=';')&&(s[0]!='#')){
egg_properties*ep= new egg_properties;
ep->setFromCSV(s);
eggs.insert(make_pair(ep->eggNumber,ep));
eggv.push_back(ep);
}
}
}

/*:71*//*72:*/
#line 2196 "eggdata.w"

void egg_properties_database::loadFromCSV(string fileName){
ifstream icsv(fileName.c_str());

loadFromCSV(icsv);
}

/*:72*//*73:*/
#line 2208 "eggdata.w"

void egg_properties_database::describe(ostream&o){
map<unsigned int,egg_properties*> ::iterator e= eggs.begin();

while(e!=eggs.end()){
(e->second)->describe(o);
e++;
}
}

void egg_properties_database::tabulate(ostream&o){
map<unsigned int,egg_properties*> ::iterator e= eggs.begin();

o<<"\
 Egg    Latitude  Longitude    Alt  REG Type   Location                 Host"<<endl;

while(e!=eggs.end()){
(e->second)->tabulate(o);
e++;
}
}


/*:73*/
#line 157 "eggdata.w"


/*:5*/
#line 106 "eggdata.w"


/*:2*/
