/*39:*/
#line 838 "examples.w"

/*47:*/
#line 964 "examples.w"


/*51:*/
#line 1061 "examples.w"


#include "config.h"         
#define REVDATE "22nd February 2002" \

#define EGGS_CSV "eggs.csv"
#define ROTTEN_CSV "rotten_egg.csv" \


#line 1064 "examples.w"


#include "analysis.h"       
#include "fourier.h"     

#include <stdio.h> 
#include <stdlib.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif

/*:51*/
#line 966 "examples.w"
;

/*50:*/
#line 1040 "examples.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:50*/
#line 968 "examples.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

/*49:*/
#line 1006 "examples.w"

int opt;

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:49*/
#line 977 "examples.w"
;

/*:47*/
#line 839 "examples.w"
;
eggdatabases ed;
ed.set_local_defaults();
generic_eggsummary_cache<egganalysis> ec(&ed,ROTTEN_CSV,50,150);

/*:39*//*40:*/
#line 853 "examples.w"

systemtime thisdate("2002-01-06");
const int numDays= 7;

cout<<"   Date     Day    Min. Dev.   Max Dev.    Delta Dev."<<endl;

/*:40*//*41:*/
#line 869 "examples.w"

for(int i= 0;i<numDays;i++){
egganalysis*esr= ec.get_by_date(thisdate);
esr->compute_all_egg_statistics();

/*:41*//*42:*/
#line 884 "examples.w"


double chisum= 0,mindev= 1e100,maxdev= -1e100;
int nitems= esr->seconds_of_data/esr->seconds_per_row;
double cxebase;

for(int j= 0;j<nitems;j++){
double zsquare= esr->stouffer_z[j]*esr->stouffer_z[j];
double xe= chiSquareDistribution::x_from_p_k(0.5,j+1);

chisum+= zsquare;
double deviation= chisum-xe;
if(deviation<mindev){
mindev= deviation;
}
if(deviation> maxdev){
maxdev= deviation;
}
}

/*:42*//*43:*/
#line 909 "examples.w"

static const char*dayOfWeek[7]= {
"Sun","Mon","Tue","Wed","Thu","Fri","Sat"
};
cout.setf(ios::fixed,ios::floatfield);
cout.precision(3);
cout<<thisdate.dateToString()<<"  "<<
dayOfWeek[thisdate.weekday()]<<"  "<<
setw(10)<<mindev<<"  "<<
setw(10)<<maxdev<<"  "<<
setw(10)<<(maxdev-mindev)<<endl;

/*:43*//*44:*/
#line 938 "examples.w"

thisdate.nextDay();
ec.purge();
}
/*48:*/
#line 983 "examples.w"

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}


/*:48*/
#line 942 "examples.w"
;


/*:44*/
